// dispbmp.cpp : implementation file
//

#include "stdafx.h"
#include "db_bmp.h"


#ifndef _dbBitmap_
#include "dbbitmap.h"
#endif

#ifndef _DispBmp_
#include "dispbmp.h"
#endif

#ifndef _DbBmpRec_
#include "dbbmprec.h"
#endif

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// DisplayBmp dialog

BEGIN_MESSAGE_MAP(DisplayBmp, CDialog)
    //{{AFX_MSG_MAP(DisplayBmp)
    ON_CBN_SELCHANGE(IDC_CMB_BMP, OnSelchangeBmp)
    ON_WM_SHOWWINDOW()
    ON_WM_PAINT()
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()



DisplayBmp::DisplayBmp(CWnd* parent,CDatabase* db)
    : CDialog(DisplayBmp::IDD, parent),pDB(db),pBmp(NULL)
{
    if(Create(IDD,parent))
        {
        ShowWindow(SW_SHOWNORMAL);
        UpdateWindow();
        }
    
    //{{AFX_DATA_INIT(DisplayBmp)
        // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}


DisplayBmp::~DisplayBmp(void)
{
    if(pBmp)
        delete pBmp;
        
}


void DisplayBmp::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(DisplayBmp)
        // NOTE: the ClassWizard will add DDX and DDV calls here
    //}}AFX_DATA_MAP
}


void DisplayBmp::PostNcDestroy(void)
{
    delete this;
}
    

void DisplayBmp::DisplayBitmap(void)
{
    if(pBmp && pBmp->m_hObject)
        {
        BITMAP bm;
        CClientDC dc(this);
        CDC memDC;
        memDC.CreateCompatibleDC(&dc);
        memDC.SelectObject(pBmp);
        
        pBmp->GetObject(sizeof(BITMAP),&bm);
        
        dc.StretchBlt(bmpRect.left,bmpRect.top,
                      (bmpRect.right - bmpRect.left),
                      (bmpRect.bottom - bmpRect.top),
                      &memDC,0,0,bm.bmWidth,bm.bmHeight,SRCCOPY);
                      
        
        }
    
}


/////////////////////////////////////////////////////////////////////////////
// DisplayBmp message handlers

void DisplayBmp::OnSelchangeBmp()
{
    // TODO: Add your control notification handler code here
    CComboBox* cmb= (CComboBox*)GetDlgItem(IDC_CMB_BMP);
    int idx= CB_ERR;
    
    if(cmb)
        {
        idx= cmb->GetCurSel();    
        if(idx != CB_ERR)
            {
            idx= (int)cmb->GetItemData(idx);
            pBmp->fetch(idx,pDB);
            DisplayBitmap();
            }
        }
        
}

void DisplayBmp::OnCancel()
{
    // TODO: Add extra cleanup here
    
    ShowWindow(SW_HIDE);
    DestroyWindow();
    
}

BOOL DisplayBmp::OnInitDialog()
{
    BOOL ret= CDialog::OnInitDialog();
    int idx= CB_ERR;
    
    if(!pBmp)
        pBmp= new dbBitmap;
        
    // TODO: Add extra initialization here
    CWnd* wnd= GetDlgItem(IDC_BMP_BMP);
    if(wnd)
        {
        wnd->GetWindowRect(&bmpRect);
        wnd->DestroyWindow();
        ScreenToClient(&bmpRect);
        }
        
    CComboBox* cmb= (CComboBox*)GetDlgItem(IDC_CMB_BMP);
    
    // ***** fill the combobox with the descriptions and *****
    // ***** the id's of all the bitmaps in database.    *****
    if(cmb)
        {
        TRY
            {
            dbBmpRecordset rs(pDB);
            rs.Open();
            rs.MoveFirst();
            while(!rs.IsEOF())
                {
                idx= cmb->AddString(rs.qryDescr());
                cmb->SetItemData(idx,rs.qryID());
                rs.MoveNext();
                }
            rs.Close();
            }
        CATCH(CDBException,e)
            {
            OutputDebugString(e->m_strError);
            OutputDebugString(e->m_strStateNativeOrigin);
            }
        END_CATCH
        }
    
    return(ret);
}


// ***** Simulate a Modal Dialog and center the *****
// ***** dialog on the screen.                  *****
void DisplayBmp::OnShowWindow(BOOL bShow, UINT nStatus)
{
    if(!bShow)
        AfxGetMainWnd()->EnableWindow(TRUE);
        
    CDialog::OnShowWindow(bShow, nStatus);
    
    // TODO: Add your message handler code here
    if(bShow)
        {
        AfxGetMainWnd()->EnableWindow(FALSE);
        
        CRect rc;
        int width= GetSystemMetrics(SM_CXSCREEN);
        int height= GetSystemMetrics(SM_CYSCREEN);
        GetWindowRect(&rc);
    
        // ***** set the origin of the window *****    
        int x_org= (width - (rc.right - rc.left)) / 2;
        int y_org= (height - (rc.bottom - rc.top)) / 2;
    
        if(y_org < (height / 3))
            y_org= (height / 3);
        
        rc.right= x_org + (rc.right - rc.left);
        rc.left= x_org;
        rc.bottom= y_org + (rc.bottom - rc.top);
        rc.top= y_org;
    
        MoveWindow(&rc);
        }    

    
}

void DisplayBmp::OnPaint()
{
    CPaintDC dc(this); // device context for painting
    
    // TODO: Add your message handler code here
    if(pBmp && pBmp->m_hObject)
        {
        BITMAP bm;
        CDC memDC;
        memDC.CreateCompatibleDC(&dc);
        memDC.SelectObject(pBmp);
        
        pBmp->GetObject(sizeof(BITMAP),&bm);
        
        dc.StretchBlt(bmpRect.left,bmpRect.top,
                      (bmpRect.right - bmpRect.left),
                      (bmpRect.bottom - bmpRect.top),
                      &memDC,0,0,bm.bmWidth,bm.bmHeight,SRCCOPY);
                      
        
        }
    
    // Do not call CDialog::OnPaint() for painting messages
}
