// updbmpdb.cpp : implementation file
//

#include "stdafx.h"
#include "db_bmp.h"

#ifndef _dbBitmap_
#include "dbbitmap.h"
#endif

#ifndef _UpdBmpDB_
#include "updbmpdb.h"
#endif

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// UpdBmpDB dialog

BEGIN_MESSAGE_MAP(UpdBmpDB, CDialog)
    //{{AFX_MSG_MAP(UpdBmpDB)
    ON_WM_SHOWWINDOW()
    ON_WM_PAINT()
    ON_BN_CLICKED(IDC_BTTN_SAVE, OnSave)
    ON_BN_CLICKED(IDC_BTTN_BROWSE, OnBrowse)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()



UpdBmpDB::UpdBmpDB(CWnd* parent,CDatabase* db)
    : CDialog(UpdBmpDB::IDD, parent),pBmp(NULL),pDB(db)
{
    //{{AFX_DATA_INIT(UpdBmpDB)
    szDescr = "";
    szFile = "";
    szID = "";
    //}}AFX_DATA_INIT
    
    if(Create(IDD,parent))
        {
        ShowWindow(SW_SHOWNORMAL);
        UpdateWindow();
        }
        
}


UpdBmpDB::~UpdBmpDB(void)
{
    if(pBmp)
        {
        if(pBmp->m_hObject)
            ::DeleteObject(pBmp->Detach());
        delete pBmp;
        }
}

void UpdBmpDB::PostNcDestroy(void)
{
    delete this;
}
    

BOOL UpdBmpDB::OnInitDialog()
{
    BOOL ret= CDialog::OnInitDialog();
    
    // TODO: Add extra initialization here
    CWnd* wnd= GetDlgItem(IDC_BMP_BMP);
    if(wnd)
        {
        wnd->GetWindowRect(&bmpRect);
        wnd->DestroyWindow();
        ScreenToClient(&bmpRect);
        }
    
    
    txtBmpID.SubclassEdit(IDC_BMP_TXT_IDENT,this);
    txtBmpID.SetMask("9999");
    
    
    if(!pBmp)
        pBmp= new dbBitmap;
        
    return(ret);
}

void UpdBmpDB::DisplayBitmap(void)
{
    if(pBmp && pBmp->m_hObject)
        {
        BITMAP bm;
        CClientDC dc(this);
        CDC memDC;
        memDC.CreateCompatibleDC(&dc);
        memDC.SelectObject(pBmp);
        
        pBmp->GetObject(sizeof(BITMAP),&bm);
        
        dc.StretchBlt(bmpRect.left,bmpRect.top,
                      (bmpRect.right - bmpRect.left),
                      (bmpRect.bottom - bmpRect.top),
                      &memDC,0,0,bm.bmWidth,bm.bmHeight,SRCCOPY);
                      
        
        }
    

}

void UpdBmpDB::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    
    if(pBmp)
        {
        //{{AFX_DATA_MAP(UpdBmpDB)
        DDX_Text(pDX, IDC_BMP_TXT_DESCR, pBmp->qryDescr());
        DDV_MaxChars(pDX, pBmp->qryDescr(), 255);
        
        DDX_Text(pDX, IDC_BMP_TXT_IDENT, szID);
        DDV_MaxChars(pDX, szID, 5);
        
        if(szID.GetLength())
            {
            pBmp->qryID()= atoi(szID.GetBuffer(szID.GetLength()));
            }
        else
            pBmp->qryID()= 0;
            
        //}}AFX_DATA_MAP
        }
}

/////////////////////////////////////////////////////////////////////////////
// UpdBmpDB message handlers

// ***** Simulate a Modal Dialog and center the *****
// ***** dialog on the screen.                  *****
void UpdBmpDB::OnShowWindow(BOOL bShow, UINT nStatus)
{
    if(!bShow)
        AfxGetMainWnd()->EnableWindow(TRUE);
        
    CDialog::OnShowWindow(bShow, nStatus);
    
    // TODO: Add your message handler code here
    if(bShow)
        {
        AfxGetMainWnd()->EnableWindow(FALSE);
        
        CRect rc;
        int width= GetSystemMetrics(SM_CXSCREEN);
        int height= GetSystemMetrics(SM_CYSCREEN);
        GetWindowRect(&rc);
    
        // ***** set the origin of the window *****    
        int x_org= (width - (rc.right - rc.left)) / 2;
        int y_org= (height - (rc.bottom - rc.top)) / 2;
    
        if(y_org < (height / 3))
            y_org= (height / 3);
        
        rc.right= x_org + (rc.right - rc.left);
        rc.left= x_org;
        rc.bottom= y_org + (rc.bottom - rc.top);
        rc.top= y_org;
    
        MoveWindow(&rc);
        }    

}

void UpdBmpDB::OnPaint()
{
    CPaintDC dc(this); // device context for painting
    
    // TODO: Add your message handler code here
    if(pBmp && pBmp->m_hObject)
        {
        BITMAP bm;
        CDC memDC;
        memDC.CreateCompatibleDC(&dc);
        memDC.SelectObject(pBmp);
        
        pBmp->GetObject(sizeof(BITMAP),&bm);
        
        dc.StretchBlt(bmpRect.left,bmpRect.top,
                      (bmpRect.right - bmpRect.left),
                      (bmpRect.bottom - bmpRect.top),
                      &memDC,0,0,bm.bmWidth,bm.bmHeight,SRCCOPY);
                      
        
        }
    
    // Do not call CDialog::OnPaint() for painting messages
}

void UpdBmpDB::OnCancel()
{
    // TODO: Add extra cleanup here
    
    ShowWindow(SW_HIDE);
    DestroyWindow();
    
}

void UpdBmpDB::OnSave()
{
    // TODO: Add your control notification handler code here
    UpdateData();
    
    // ***** store the bitmap if a valid id *****
    if(pBmp && pBmp->qryID())
        pBmp->store(pDB);
        
}



void UpdBmpDB::OnBrowse()
{
    // TODO: Add your control notification handler code here
    DWORD dwFileStyle= OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
    CString defext("bmp");
    CString deffile("*.bmp");
    CString filter("Bitmap Files (*.bmp) | *.bmp||");
    CString file;
    CString ext;
    int err= 0;
    
    CFileDialog dlg(TRUE,defext,deffile,
                    dwFileStyle,filter,this);
    if(dlg.DoModal() == IDOK)
        {
        // ***** Support only for bitmaps initially *****
        ext= dlg.GetFileExt();
        ext.MakeUpper();
        defext.MakeUpper();
        if(ext != defext)
            {
            #ifdef _DEBUG
            file= "Error!!!!\n\nThe file extension is not a bitmap file!\n";
            OutputDebugString(file);
            #endif
            err= TRUE;
            }
        else
            {
            file= dlg.GetPathName();
            GetDlgItem(IDC_BMP_TXT_FILE)->SetWindowText(file);
            err= FALSE;
            }
        
            
        // ***** load the selected bitmap file *****
        if(!err)
            {
            if(pBmp)
                {
                if(pBmp->m_hObject)
                    ::DeleteObject(pBmp->Detach());
                }
            else
                pBmp= new dbBitmap;
                
            pBmp->ReadBmpFile(file);
            DisplayBitmap();
            }
        
        }
    
}
